package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type DeleteFloatingIPLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewDeleteFloatingIPLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DeleteFloatingIPLogic {
	return &DeleteFloatingIPLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *DeleteFloatingIPLogic) DeleteFloatingIP(req *types.DeleteFloatingIPReq) (resp *types.DeleteFloatingIPResp, err error) {
	// todo: add your logic here and delete this line
	DeleteFloatingIPReq := &openstack.DeleteFloatingIPReq{}
	err = copier.CopyWithOption(DeleteFloatingIPReq, req, copier.Option{Converters: utils.Converters})
	DeleteFloatingIPResp, err := l.svcCtx.OpenstackRpc.DeleteFloatingIP(l.ctx, DeleteFloatingIPReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&DeleteFloatingIPResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &DeleteFloatingIPResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
